import 'dart:convert';

import 'package:http/http.dart' as http;
import 'package:odoo_rest_api/src/odoo_models.dart';
import 'package:odoo_rest_api/src/odoo_constans.dart';

abstract class OdooConnector {
  http.Client _client;
  String _serverURL;

  OdooConnector(String serverURL) {
    this._serverURL = serverURL;
    _client = http.Client();
  }

  Future<OdooResponse> callRequest(String path, Map payload) async {
    var body = json.encode(payload);
    final response = await _client.post(_serverURL + path, body: body, headers: OdooConstants.DEFAULT_HEADER);
    return new OdooResponse(json.decode(response.body), response.statusCode);
  }
}
